/*
 * FMATHADD is distributed under the GNU GENERAL PUBLIC LICENSE (GPL)
 * Version 2 (June 1991). See the "COPYING" file distributed with this
 * software for more info.
 *
 * Copyright (C) 2001 by Michael Schroeder <mdhs@gmx.net>
 */


#include <stdlib.h>
#include <string.h>

#include "fmath.h"
#include "starcalc.h"
#include "locals.h"



/*
 * Gamma-Funktion
 */
SO_CALLBACK(SC_gamma, double *r, double *x)
{
  *r = gamma(*x);
}


/*
 * Besselsche Funktion 1. Gattung n-ter Ordnung
 */
SO_CALLBACK(SC_bessel, double *r, double *x, double *n)
{
  *r = jn((int)*n, *x);
}


/*
 * Besselsche Funktion 2. Gattung n-ter Ordnung (Webersche Funktion)
 */
SO_CALLBACK(SC_weber, double *r, double *x, double *n)
{
  *r = yn((int)*n, *x);
}

