/*
 * FMATHADD is distributed under the GNU GENERAL PUBLIC LICENSE (GPL)
 * Version 2 (June 1991). See the "COPYING" file distributed with this
 * software for more info.
 *
 * Copyright (C) 2001 by Michael Schroeder <mdhs@gmx.net>
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "fmath.h"
#include "starcalc.h"
#include "locals.h"



/*
 * Zahl als Euro-Waehrung formatieren
 */
SO_CALLBACK(SC_euro, char *r, double *x, double *digits)
{
  char buf[256];

  sprintf(buf, "%.*f EUR", (int)*digits, *x);

  SO_StringCopy(r, buf);
}


/*
 * Umwandlung einer Zahl in IEEE-Format
 */
SO_CALLBACK(SC_ieee, char *r, double *x)
{
  fltoie(*x, r);
}


/*
 * Umwandlung einer roemischen Zahl in eine Dezimalzahl
 */
SO_CALLBACK(SC_roman, double *r, char *s)
{
  if (strtok(s, "ivxlcdmIVXLCDM")) {	/* nur zugelassene Zeichen */
    *r = INVALID;
    return;
  }
  
  *r = (double)roman(s);
}


/*
 * Umwandlung einer Zahl in ein Zahlwort
 */
SO_CALLBACK(SC_word, char *r, double *x)
{
  char buf[256];
  int i;

  gcvt(*x, 0, buf);

  i = strlen(buf);

    
  
}

