/*
 * Description:	StarOffice spreadsheet header definitions (GNU C/C++)
 *
 *	(c) 2000 by Michael Schroeder <mdhs@gmx.net>
 */

#ifndef STARCALC_H
# define STARCALC_H

#define LANGUAGE_DONTKNOW		0x03FF
#define LANGUAGE_SYSTEM 		0x0000
#define LANGUAGE_AFRIKAANS		0x0436
#define LANGUAGE_ALBANIAN		0x041C
#define LANGUAGE_ARABIC 		0x0401
#define LANGUAGE_ARABIC_IRAQ		0x0801
#define LANGUAGE_ARABIC_EGYPT		0x0C01
#define LANGUAGE_ARABIC_LIBYA		0x1001
#define LANGUAGE_ARABIC_ALGERIA 	0x1401
#define LANGUAGE_ARABIC_MOROCCO 	0x1801
#define LANGUAGE_ARABIC_TUNISIA 	0x1C01
#define LANGUAGE_ARABIC_OMAN		0x2001
#define LANGUAGE_ARABIC_YEMEN		0x2401
#define LANGUAGE_ARABIC_SYRIA		0x4001
#define LANGUAGE_ARABIC_JORDAN		0x4401
#define LANGUAGE_ARABIC_LEBANON 	0x4801
#define LANGUAGE_ARABIC_KUWAIT		0x4C01
#define LANGUAGE_ARABIC_UAE 		0x5001
#define LANGUAGE_ARABIC_BAHRAIN 	0x5401
#define LANGUAGE_ARABIC_QATAR		0x5801
#define LANGUAGE_BASQUE 		0x042D
#define LANGUAGE_BULGARIAN		0x0402
#define LANGUAGE_BELARUSIAN 		0x0423
#define LANGUAGE_CATALAN		0x0403
#define LANGUAGE_CHINESE		0x0004
#define LANGUAGE_CHINESE_TRADITIONAL	0x0404
#define LANGUAGE_CHINESE_SIMPLIFIED	0x0804
#define LANGUAGE_CHINESE_HONGKONG	0x0C04
#define LANGUAGE_CHINESE_SINGAPORE	0x1004
#define LANGUAGE_CROATIAN		0x041A
#define LANGUAGE_CZECH			0x0405
#define LANGUAGE_DANISH 		0x0406
#define LANGUAGE_DUTCH			0x0413
#define LANGUAGE_DUTCH_BELGIAN		0x0813
#define LANGUAGE_ENGLISH		0x0009
#define LANGUAGE_ENGLISH_US 		0x0409
#define LANGUAGE_ENGLISH_UK 		0x0809
#define LANGUAGE_ENGLISH_AUS		0x0C09
#define LANGUAGE_ENGLISH_CAN		0x1009
#define LANGUAGE_ENGLISH_NZ 		0x1409
#define LANGUAGE_ENGLISH_EIRE		0x1809
#define LANGUAGE_ENGLISH_SAFRICA	0x1C09
#define LANGUAGE_ENGLISH_JAMAICA	0x2009
#define LANGUAGE_ENGLISH_CARRIBEAN	0x2409
#define LANGUAGE_ENGLISH_BELIZE 	0x2809
#define LANGUAGE_ENGLISH_TRINIDAD	0x2C09
#define LANGUAGE_ENGLISH_ZIMBABWE	0x3009
#define LANGUAGE_ENGLISH_PHILIPPINES	0x3409
#define LANGUAGE_ESTONIAN		0x0425
#define LANGUAGE_FAEROESE		0x0438
#define LANGUAGE_FARSI			0x0429
#define LANGUAGE_FINNISH		0x040B
#define LANGUAGE_FRENCH 		0x040C
#define LANGUAGE_FRENCH_BELGIAN 	0x080C
#define LANGUAGE_FRENCH_CANADIAN	0x0C0C
#define LANGUAGE_FRENCH_SWISS		0x100C
#define LANGUAGE_FRENCH_LUXEMBOURG	0x140C
#define LANGUAGE_FRENCH_MONACO		0x180C
#define LANGUAGE_GERMAN 		0x0407
#define LANGUAGE_GERMAN_SWISS		0x0807
#define LANGUAGE_GERMAN_AUSTRIAN	0x0C07
#define LANGUAGE_GERMAN_LUXEMBOURG	0x1007
#define LANGUAGE_GERMAN_LIECHTENSTEIN	0x1407
#define LANGUAGE_GREEK			0x0408
#define LANGUAGE_HEBREW 		0x040D
#define LANGUAGE_HUNGARIAN		0x040E
#define LANGUAGE_ICELANDIC		0x040F
#define LANGUAGE_INDONESIAN 		0x0421
#define LANGUAGE_ITALIAN		0x0410
#define LANGUAGE_ITALIAN_SWISS		0x0810
#define LANGUAGE_JAPANESE		0x0411
#define LANGUAGE_KOREAN 		0x0412
#define LANGUAGE_KOREAN_JOHAB		0x0812
#define LANGUAGE_LATVIAN		0x0426
#define LANGUAGE_LITHUANIAN 		0x0427
#define LANGUAGE_MACEDONIAN 		0x042f
#define LANGUAGE_MALAY			0x043e
#define LANGUAGE_NORWEGIAN		0x0014
#define LANGUAGE_NORWEGIAN_BOKMAL	0x0414
#define LANGUAGE_NORWEGIAN_NYNORSK	0x0814
#define LANGUAGE_POLISH 		0x0415
#define LANGUAGE_PORTUGUESE 		0x0816
#define LANGUAGE_PORTUGUESE_BRAZILIAN	0x0416
#define LANGUAGE_RHAETO_ROMAN		0x0417
#define LANGUAGE_ROMANIAN		0x0418
#define LANGUAGE_RUSSIAN		0x0419
#define LANGUAGE_SLOVAK 		0x041B
#define LANGUAGE_SLOVENIAN		0x0424
#define LANGUAGE_SORBIAN		0x042E
#define LANGUAGE_SPANISH		0x040A
#define LANGUAGE_SPANISH_MEXICAN	0x080A
#define LANGUAGE_SPANISH_MODERN 	0x0C0A
#define LANGUAGE_SPANISH_GUATEMALA	0x100A
#define LANGUAGE_SPANISH_COSTARICA	0x140A
#define LANGUAGE_SPANISH_PANAMA 	0x180A
#define LANGUAGE_SPANISH_DOMINICAN	0x1C0A
#define LANGUAGE_SPANISH_VENEZUELA	0x200A
#define LANGUAGE_SPANISH_COLOMBIA	0x240A
#define LANGUAGE_SPANISH_PERU		0x280A
#define LANGUAGE_SPANISH_ARGENTINA	0x2C0A
#define LANGUAGE_SPANISH_ECUADOR	0x300A
#define LANGUAGE_SPANISH_CHILE		0x340A
#define LANGUAGE_SPANISH_URUGUAY	0x380A
#define LANGUAGE_SPANISH_PARAGUAY	0x3C0A
#define LANGUAGE_SPANISH_BOLIVIA	0x400A
#define LANGUAGE_SPANISH_EL_SALVADOR	0x440A
#define LANGUAGE_SPANISH_HONDURAS	0x480A
#define LANGUAGE_SPANISH_NICARAGUA	0x4C0A
#define LANGUAGE_SPANISH_PUERTO_RICO	0x500A
#define LANGUAGE_SWEDISH		0x041D
#define LANGUAGE_SWEDISH_FINLAND	0x081D
#define LANGUAGE_THAI			0x041E
#define LANGUAGE_TURKISH		0x041F
#define LANGUAGE_UKRAINIAN		0x0422
#define LANGUAGE_URDU			0x0420
#define LANGUAGE_VIETNAMESE 		0x042a
#define LANGUAGE_USER1			0x0201
#define LANGUAGE_USER2			0x0202
#define LANGUAGE_USER3			0x0203
#define LANGUAGE_USER4			0x0204
#define LANGUAGE_USER5			0x0205
#define LANGUAGE_USER6			0x0206
#define LANGUAGE_USER7			0x0207
#define LANGUAGE_USER8			0x0208
#define LANGUAGE_USER9			0x0209


/*
 * Umlauts
 */
#ifdef LATIN1			/* ANSI, Latin1, ISO-8859-1 */
# define _DG		'\xb0'
# define _MY		'\xb5'
# define _AE		'\xc4'
# define _OE		'\xf6'
# define _UE		'\xdc'
# define _ae		'\xe4'
# define _oe		'\xf6'
# define _ue		'\xfc'
# define _ss		'\xdf'
# define DG		"\xb0"
# define MY		"\xb5"
# define AE		"\xc4"
# define OE		"\xf6"
# define UE		"\xdc"
# define ae		"\xe4"
# define oe		"\xf6"
# define ue		"\xfc"
# define ss		"\xdf"
#else				 /* IBM-PC, CP-437, CP-850 */
# define _DG		'\xf8'
# define _MY		'\xe6'
# define _AE		'\x8e'
# define _OE		'\x99'
# define _UE		'\x9a'
# define _ae		'\x84'
# define _oe		'\x94'
# define _ue		'\x81'
# define _ss		'\xe1'
# define DG		"\xf8"
# define MY		"\xe6"
# define AE		"\x8e"
# define OE		"\x99"
# define UE		"\x9a"
# define ae		"\x84"
# define oe		"\x94"
# define ue		"\x81"
# define ss		"\xe1"
#endif


#ifndef TRUE
# define TRUE		1
#endif
#ifndef FALSE
# define FALSE		0
#endif

#ifndef WIN
# ifdef WNT
#  define CALLTYPE	__cdecl
# else
#  define CALLTYPE
# endif
#else
# define PASCAL		_pascal
# define FAR		_far
# define CALLTYPE	FAR PASCAL
#endif


/*
 * The OS/2 addin interface is broken - brain damaged IBM compiler :-( 
 *
 * - The first three function parameters are NOT offered in the stack frame
 *   but in CPU registers - that is the strange IBM mode (so-called QUIRKS).
 *   The first 3 stack parameters contain waste...
 *
 * - ENUM has typeof char (not typeof int)!
 *
 * 
 * These macros define FASTCALL calling convention (parameters in registers)
 * and insert 3 dummy arguments in the stack frame parameter list.
 * 
 * Register  |	SO-Interface	FASTCALL	OUIRKS (this interface)
 *
 * (ESP):	ret addr	ret addr	ret addr
 * (ESP+4):	arg1 (empty)	arg4		dummy1
 * (ESP+8):	arg2 (empty)	arg5		dummy2
 * (ESP+12):	arg3 (empty)	...		dummy3
 * (ESP+16):	arg4		...		arg4
 * (ESP+20):	arg5		...		arg5
 * ( ... ):	...		...		...
 *
 * EAX:		arg1		arg1		arg1
 * EDX:		arg2		arg2		arg2
 * ECX:		arg3		arg3		arg3
 *
 *
 * Therefore you have to define callback functions with 4 and more parameters
 * with:
 *		SO_QUIRKSCALL( funcname, arg1, arg2, arg3, ... )
 *
 * You should define all other callback functions with:
 *
 *		SO_CALLBACK( funcname, arg1, ... )
 */

#ifdef QUIRKS		/* OS/2 ? */
# define PACKED			__attribute__ ((packed))
# undef CALLTYPE
# define CALLTYPE		__attribute__ ((regparm(3)))
# define DUMMYARGS		void *D1, void *D2, void *D3
# define SO_CALLBACK(func, arg1...)	void CALLTYPE func(arg1)
# define SO_QUIRKSCALL(func, arg1, arg2, arg3, arg4...)	\
	void CALLTYPE func(arg1, arg2, arg3, DUMMYARGS, arg4)
#else

# define PACKED
# define SO_CALLBACK(func, arg1...)	void CALLTYPE func(arg1)
# define SO_QUIRKSCALL(func, arg1, arg2, arg3, arg4...) \
	void CALLTYPE func(arg1, arg2, arg3, arg4)
#endif


#define INVALID_ARG	"Err:502"
#define INVALID_CAL	"Err:503"

#define Q(x)		QUOTE(x)
#define QUOTE(x)	#x

#define DESCR(n)	n ## _NAME, n ## _DESC


/*
 * All character string returns are limited to 255+1 chars
 */
#define SO_CHARSTRING_MAX	256
#define SO_StringCopy(dst, src) \
	(strncpy(dst, src, SO_CHARSTRING_MAX), dst[SO_CHARSTRING_MAX-1] = '\0')

/*
 * Conversion: StarCalc internal time <--> terrestrial dynamical time J2000
 */
#define TD2SC(x)	((x) * 36525.0 + 36526.5)
#define SC2TD(x)	(((x) - 36526.5) / 36525.0)	/* vice versa */
#define LT2SC(x)	(LMT(x) * 36525.0 + 36526.5)	/* local mean time */


/*
 * Enable all new interface features
 */
#ifndef SUPD
# define SUPD 9999
#endif


typedef unsigned char		BOOL;
typedef unsigned char		BYTE;
typedef unsigned short		USHORT;
typedef unsigned long		ULONG;


typedef enum
{
  PTR_DOUBLE,
  PTR_STRING,
  PTR_DOUBLE_ARR,
  PTR_STRING_ARR,
  PTR_CELL_ARR,
  NONE
} PACKED ParamType;		/* OS/2: packed (typeof char) */

typedef enum
{
  CELL_NUMBER,
  CELL_STRING,
} CellType;


#pragma pack(1)		/* packing is important! */

typedef struct _SO_sub_number	/* header of a number element */
{
  USHORT col;
  USHORT row;
  USHORT tab;
  USHORT error;

  double value;
} SUBNUMBER;


typedef struct _SO_number_array	/* header of a number array */
{
  USHORT col1;			/* upper left corner */
  USHORT row1;
  USHORT tab1;

  USHORT col2;			/* upper right corner */
  USHORT row2;
  USHORT tab2;
  
  USHORT count;

  SUBNUMBER  first;			/* first number element */
  /* ... */

} NUMBERARRAY;


typedef struct _SO_sub_string	/* header of a string element*/
{
  USHORT col;
  USHORT row;
  USHORT tab;
  USHORT error;
  USHORT len;

  char string[1];			/* only first character */

} SUBSTRING;


typedef struct _SO_string_array	/* header of a string array */
{
  USHORT col1;			/* upper left corner */
  USHORT row1;
  USHORT tab1;

  USHORT col2;			/* upper right corner */
  USHORT row2;
  USHORT tab2;
  
  USHORT count;

  SUBSTRING first;			/* first string element */
  /* ... */

} STRINGARRAY;


typedef struct _SO_sub_cell	/* header of a cell element */
{
  USHORT col;
  USHORT row;
  USHORT tab;
  USHORT error;
  USHORT type;

  union
  {
    double value;
    struct
    {
      USHORT len;
      char   text[1];
    } string;
  } var;

} SUBCELL;			/* can do increment number-cell with '++' */


typedef struct _SO_cell_array	/* header of a cell array */
{
  USHORT col1;			/* upper left corner */
  USHORT row1;
  USHORT tab1;

  USHORT col2;			/* upper right corner */
  USHORT row2;
  USHORT tab2;
  
  USHORT count;

  SUBCELL first;		/* first cell element */
  /* ... */

} CELLARRAY;

#pragma pack()


/* Increment pointer to the next cell.
 * The StarOffice help is incorrect: If the string length is odd NO second
 * zero byte ('\0') will be added to the string.
 * So the contents of the len-field sometimes is false!
 */
#define NEXTSTRING(c)	(void*)c += 10L + c->len - (c->string[c->len-2] == 0)
#define NEXTCELL(c)	(void*)c += 12L + c->var.string.len - \
			         (c->var.string.text[c->var.string.len-2] == 0)

/*
 * array aritmethic: array could be 1D or 2D (???3D with tab???)
 */
#define DIMCOLS(a)	(a->col2 - a->col1)
#define DIMROWS(a)	(a->row2 - a->row1)
#define ISDIM2(a)	((a->col1 != a->col2) && (a->row1 != a->row2)) 
#define ISDIM1(a)	!ISDIM2(1)
#define ISSQUARE(a)	(DIMCOLS(a) == DIMROWS(a))
#define ISDATX2(a)	((DIMCOLS(a) == 1) || (DIMROWS(a) == 1))
#define ISODD(c)	((c & 1) != 0)
#define ISEVEN(c)	((c & 1) == 0)


#if defined (__cplusplus)
extern "C" {
#endif

typedef void (CALLTYPE *AdvData)(double *nHandle, void *pData);

SO_CALLBACK( GetFunctionCount, USHORT *nCount );

SO_QUIRKSCALL( GetFunctionData,
		USHORT    *nNo,
		char      *pFuncName,
		USHORT    *nParamCount,
		ParamType *peType,
		char      *pInternalName );

SO_CALLBACK( IsAsync, USHORT *nNo, ParamType *peType );

SO_CALLBACK( Advice, USHORT *nNo, AdvData *pfCallback );

SO_CALLBACK( Unadvice, double *nHandle );

#if (SUPD>=398)		/* new in StarOffice 5.0 */

SO_QUIRKSCALL( GetParameterDescription,
		USHORT *nNo,
		USHORT *nParam,
		char *pName,
		char *pDesc );

#endif

#if (SUPD>=506)		/* new in StarOffice 5.1 */

SO_CALLBACK( SetLanguage, USHORT *nLanguage );

#endif


/*
 * Simplify programming: Do most of the language stuff here.
 *
 * Supported languages are english und german but it's easy to add more.
 */
#ifdef INCL_NLANGUAGE

#define _LANG(x)	LANGUAGE_##x

#define _EXPLAIN(l,e)	case _LANG(l): return (e)

#define EXPLAIN(parm,eng,ger)				\
		case parm:				\
		  switch (_nLanguage) {			\
		    _EXPLAIN(GERMAN,ger); 		\
		    default: _EXPLAIN(ENGLISH,eng); 	\
		  }					\
		  break

  /* the following code is always ever the same, so do the work here */

static USHORT _nLanguage = LANGUAGE_GERMAN;	/* default value */

SO_CALLBACK ( SetLanguage, USHORT *nLanguage )
{
  USHORT nLang = *nLanguage & LANGUAGE_DONTKNOW;

  if (nLang >= 0x0200)		/* ignore LANGUAGE_USER */
    return;

  /* reduce special languages to their stem */

  switch (nLang |= 0x0400) {

    case LANGUAGE_CHINESE_TRADITIONAL:
      _nLanguage = LANGUAGE_CHINESE;
      break;

    case LANGUAGE_ENGLISH_US:
      _nLanguage = LANGUAGE_ENGLISH;
      break;

    case LANGUAGE_NORWEGIAN_BOKMAL:
      _nLanguage = LANGUAGE_NORWEGIAN;
      break;

    case LANGUAGE_PORTUGUESE_BRAZILIAN:
      _nLanguage = LANGUAGE_PORTUGUESE;
      break;

    default:
      _nLanguage = nLang;
      break;
  }
}
#endif

#if defined (__cplusplus)
}
#endif

#endif		/* STARCALC_H */
